
import java.util.*;
import java.io.*;

// RTILauncher Stuff
import comprti.*;
import comprti.msg.*;

// Chat stuff
import chat.control.*;
import chat.gui.*;

/** 
*/
public class ChatMessageHandler implements MessageHandler, ChatControl {
    String fedName ;
    ChatView view; 
    runChat1 boss;
    RTIContext cnt; 
    MessagePublisher publish;
    public ChatMessageHandler(runChat1 _boss,RTIContext _cnt,String _fedName ) 
    { boss=_boss; cnt=_cnt; fedName=_fedName; publish = cnt.getMessagePublisher(fedName);}
    public void setView(ChatView _view) { view=_view; }

    // ChatControl Interface
    public void doExit() {} ;
    public void doConnect() {} ;
    public void doDisconnect() {} ;
    public void doMail(String msg) {
      System.out.println("Mail:"+msg);
      if(cnt!=null) {
        MessageFactory msgFac = cnt.getMessageFactory(fedName);
        publish.push(msgFac.createUpdateParamaterMessage(boss,"Chatter","Message",msg.getBytes()));
      }// end of if
    } 
    public boolean isConnected() { return true; }
    // MessageHandler Interface
    public void handleMessage(Message inMsg) { 
      System.out.println("ChatMessageHandler.handleMessage("+inMsg+")!");
      if(inMsg instanceof comprti.msg.UpdateParameterMessage) {
        UpdateParameterMessage upm = (UpdateParameterMessage)inMsg; 
        //String msg = new String(upm.getValue());
        //System.out.println(upm.getInteractionClassName()+"."+upm.getParameterName()+": "+msg); 
        if(view!=null) view.addMessage(upm.getValue());
      }
    }
    public void setChatterMessage(byte[] msg) {
      String m = new String(msg);
      System.out.println("ChatMessageHandler.setChatterMessage("+m+")!");
      if(view!=null) view.addMessage(msg);
    }

} /* end of class ChatMessageHandler */
