//package comprti;
import java.util.*;
import java.net.*;
import java.io.*;import javax.swing.*;
import comprti.*;
import xml.*;
import lrti.*;
import com.sun.xml.tree.*;
import org.w3c.dom.*;
import org.xml.sax.*;
import comprti.msg.*;
/** 
* 
* @see 
* @author 
*/
public class RTIContextFactory {
  static RTIComponentLoader loader = new RTIComponentLoader(".");

  public static RTIContextImpl 
  create(ComponentRecord aRec,RTIContextRegistry cnxreg,FederationsRegistry fedreg, AppletProps app) {
    RTIContextImpl ret = null;
    RTIComponentDocument compDocs = getRTIComponentDocument(app,aRec);
    if(compDocs!=null) {
      RTIComponent component = loadComponent(compDocs);
      ret = new RTIContextImpl(cnxreg,compDocs,fedreg);
      configure(ret, compDocs.getInvolvedFederations(),fedreg); 
      ImageIcon theImage = null;
      try { theImage=new ImageIcon(new URL(app.getCodeBase()+aRec.getImageFileName())); }
      catch(java.net.MalformedURLException mue) {}
      RTIContextView v = new RTIContextView(ret,aRec.getComponentName(),theImage);
      ret.setView(v);
      ret.setRTIComponent(component);
      cnxreg.addRTIContext(ret);
    }// end of if
    return ret;
  }// end of create()
  static RTIComponentDocument getRTIComponentDocument(AppletProps app,ComponentRecord aRec ) {
    RTIComponentDocument compDocs = null;
    try {
       org.w3c.dom.Document dom = XmlDocument.createXmlDocument(app.getCodeBase()+System.getProperty("file.separator")+aRec.getDefFileName());
       compDocs = new RTIComponentDocument(dom);
       String cName = compDocs.getComponentName();
       /*compProperties = compDocs.getProperties();
       System.out.println("cName:"+cName);
       compDocs.printSummary(new PrintStream(System.out,true));
       component = boss.loadComponent(cName); 
       if( component!=null ) { 
         component.setContext(this); 
         component.created(); 
         componentState=RTIComponent.COMPONENT_CREATED;
       } else  System.out.println("component is NULL!! ");*/
     } catch(java.io.IOException ioe) {}
       catch(org.xml.sax.SAXException saxe) {}
    return compDocs;
  }// end of loadComponent()
  static RTIComponent loadComponent(RTIComponentDocument compDocs) {
   return loadComponent(compDocs.getComponentName());
  }// end of loadComponent()   
  static RTIComponent loadComponent( String compName ) {
     return loader.loadRTIComponentObject(compName);
  }// end of loadComponent()
  static void configure( RTIContext cnx, Hashtable feds, FederationsRegistry fedreg) {
     String fName=null;
     JoinedFedInfo fInfo=null;
     FederationDefinition fDef=null;
     Enumeration keys = feds.keys();
     while( keys.hasMoreElements() ) 
       try {
         if( (fName=(String)keys.nextElement())!=null &&
             (fInfo=(JoinedFedInfo)feds.get(fName))!=null && 
             (fDef=fedreg.get(fName))!=null ) 
             fDef.configure(cnx,fInfo); 
       } catch(IllegalArgumentException iae) {}
  }// end of configure()
}// end of class RTIContextFactory 
