//package comprti;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import javax.swing.event.*;
import java.net.*;
import java.io.*;

import comprti.*;
import comprti.msg.*;
import comprti.cback.*;
import lrti.*;
import xml.*;
import util.*;

import com.sun.xml.tree.*;
import org.w3c.dom.*;
import org.xml.sax.*;

/** 
* 
* @see 
* @author 
*/
public class RTIContextImpl implements RTIContext {
  JPopupMenu           popup;
  JRadioButtonMenuItem activate = null;
  JRadioButtonMenuItem deactivate = null;
  JRadioButtonMenuItem remove = null;
  ComponentRecord      aRec;
  RTILauncherGUI       boss;
  RTIComponent         component;
  JButton              button; 
  int                  componentState = -1;
  Properties           compProperties = new Properties();
  RTIContextRegistry   cnxreg;
  RTIComponentDocument compDoc;
  FederationsRegistry  fdregs;
  public RTIContextImpl(JButton _button,ComponentRecord _aRec, RTILauncherGUI _boss) {
    /*popup = new JPopupMenu();
    ButtonGroup bGroup = new ButtonGroup();
    activate = new JRadioButtonMenuItem("activate");
    deactivate = new JRadioButtonMenuItem("deactivate");
    remove = new JRadioButtonMenuItem("remove");
    activate.addActionListener(this);
    deactivate.addActionListener(this);
    remove.addActionListener(this);
    popup.add(activate);popup.add(deactivate);popup.add(remove);
    bGroup.add(activate);bGroup.add(deactivate);bGroup.add(remove);

    aRec=_aRec; boss=_boss;button=_button;
    loadComponent();*/
  }
  public RTIContextImpl( RTIContextRegistry _cnxreg, 
                         RTIComponentDocument _compDoc, 
                         FederationsRegistry _fdregs) {
    cnxreg=_cnxreg;  fdregs=_fdregs;
    compDoc=_compDoc;     compProperties=compDoc.getProperties();
  }
  public void setRTIComponent(RTIComponent _component) {
    component=_component; 
    if( component!=null ) { 
        component.setContext(this); 
        component.created(); 
        componentState=RTIComponent.COMPONENT_CREATED;
    } else  System.out.println("component is NULL!! ");
  }// end of setRTIComponent()

  public RTIComponent getRTIComponent() { return component;}

  public JButton getButton() { return button;}

  Component view;
  public void setView(Component a) { view=a; }
  public Component getView() { return view; }

  public void doActivate()   { 
     if(component!=null&&componentState==RTIComponent.COMPONENT_CREATED) 
     { component.activated();componentState=RTIComponent.COMPONENT_ACTIVATED; }
     else { if(component==null) System.out.println("component is NULL!!");
            if(componentState!=RTIComponent.COMPONENT_CREATED)
             System.out.println("componentState: "+componentState);
     }   
  }

  public void doDeactivate() { 
     if(component!=null&&componentState==RTIComponent.COMPONENT_ACTIVATED) 
     { component.deactivated(); componentState=RTIComponent.COMPONENT_CREATED; } 
  }
  
  public void doRemove()     { 
     if(component!=null) { 
       if(componentState==RTIComponent.COMPONENT_ACTIVATED) doDeactivate();
       component.removed();
     }
     cnxreg.removeRTIContext(this);
  }

  void loadComponent() {
     try {
       org.w3c.dom.Document dom = XmlDocument.createXmlDocument(boss.getCodeBase()+System.getProperty("file.separator")+aRec.getDefFileName());
       RTIComponentDocument compDocs = new RTIComponentDocument(dom);
       String cName = compDocs.getComponentName();
       compProperties = compDocs.getProperties();
       System.out.println("cName:"+cName);
       compDocs.printSummary(new PrintStream(System.out,true));
       component = boss.loadComponent(cName); 
       if( component!=null ) { 
         component.setContext(this); 
         component.created(); 
         componentState=RTIComponent.COMPONENT_CREATED;
       } else  System.out.println("component is NULL!! ");
     } catch(java.io.IOException ioe) {}
       catch(org.xml.sax.SAXException saxe) {}

  }// end of loadComponent()

  public void dispose()                 { System.out.println("dispose:");}
  public Properties getProperties()     { return compProperties;}
  public String getProperty(String propertyName) 
  { return (String)compProperties.get(propertyName); }


  MessageFactory msgFdefault = null;
  Hashtable msgFmaps = new Hashtable();
  public MessageFactory getMessageFactory() {return msgFdefault;};
  public MessageFactory getMessageFactory(String federationName) 
  { return (MessageFactory)msgFmaps.get(federationName);};
  public void setMessageFactory(String federationName, MessageFactory in) 
  { msgFmaps.put(federationName,in); };
  public void setMessageFactory(MessageFactory in) { msgFdefault=in; };

  MessagePublisher msgPdefault = null;
  Hashtable msgPmaps = new Hashtable();
  public MessagePublisher getMessagePublisher() { return msgPdefault; };
  public MessagePublisher getMessagePublisher(String federationName) 
  { return (MessagePublisher)msgPmaps.get(federationName); };
  public void setMessagePublisher(String federationName, MessagePublisher in) { 
    System.out.println("setMessagePublisher(\""+federationName+"\")"); 
    msgPmaps.put(federationName,in); 
  }// end of setMessagePublisher()
  public void setMessagePublisher(MessagePublisher in) { msgPdefault=in; };
  
  public void registerMessageHandler(MessageHandler Hnd) {};
  public void registerMessageHandler(String federationName,MessageHandler Hnd) 
  { postConfigure(federationName,Hnd); };

  Hashtable cbRepoMap = new Hashtable(); 
  void postConfigure(String federationName,MessageHandler Hnd) {
    Hashtable feds = compDoc.getInvolvedFederations();
    JoinedFedInfo fInfo=(JoinedFedInfo)feds.get(federationName);
    CallbackRepository crepo = (CallbackRepository)cbRepoMap.get(federationName);
    if( crepo==null ) { 
        CallbackRegistry dummy=fInfo.getInteractionCallbackRegistry(); 
        crepo = CallbackRepositoryFactory.getAttributeCallbackRepository(Hnd,fInfo.getObjectCallbackRegistry());
        CallbackRepositoryFactory.updateParameterCallbackRepository(crepo,dummy,dummy.getEntryKeys());
        cbRepoMap.put(federationName,crepo);
    }// end of if
    FederationDefinition fDef=fdregs.get(federationName);
    if(fDef!=null&&crepo!=null&&fInfo!=null) fDef.postConfigure(this,crepo,fInfo);
  }// end of configure()
}// end of class RTIContextImpl 
