//package comprti;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import javax.swing.event.*;
import java.net.*;
import java.io.*;
import comprti.*;
import xml.*;

import com.sun.xml.tree.*;
import org.w3c.dom.*;
import org.xml.sax.*;
import comprti.msg.*;

/** A interface defining operations expected of ...
 * 
 * @see OtherClasses
 * @author your_name_here
 */
public class RTIContextImpl implements RTIContext, MouseListener, ActionListener {
  JPopupMenu           popup;
  JRadioButtonMenuItem activate = null;
  JRadioButtonMenuItem deactivate = null;
  JRadioButtonMenuItem remove = null;
  ComponentRecord      aRec;
  RTILauncherGUI       boss;
  RTIComponent         component;
  JButton              button; 
  int                  componentState = -1;
  Properties           compProperties = new Properties();
  public RTIContextImpl(JButton _button,ComponentRecord _aRec, RTILauncherGUI _boss) {
    popup = new JPopupMenu();
    ButtonGroup bGroup = new ButtonGroup();
    activate = new JRadioButtonMenuItem("activate");
    deactivate = new JRadioButtonMenuItem("deactivate");
    remove = new JRadioButtonMenuItem("remove");
    activate.addActionListener(this);
    deactivate.addActionListener(this);
    remove.addActionListener(this);
    popup.add(activate);popup.add(deactivate);popup.add(remove);
    bGroup.add(activate);bGroup.add(deactivate);bGroup.add(remove);

    aRec=_aRec; boss=_boss;button=_button;
    loadComponent();
  }
  public RTIContextImpl(RTIComponent _component,RTIContextRegistry _cnxreg, RTIComponentDocument _compDoc) {
  
  }

  // Operations
  /** An operation that does ...
 * 
 * @param firstParamName  a description of this parameter
 */
 // public void registerMessageHandler(MessageHandler Hnd);
  /** An operation that does ...
 * 
 * @param firstParamName  a description of this parameter
 */
 // public MessageFactory getMessageFactory();
  /** An operation that does ...
 * 
 * @param firstParamName  a description of this parameter
 */
 // public MessagePublisher getMessagePublisher();

   public void mousePressed(MouseEvent e) { maybeShowPopup(e); }
  
   public void mouseReleased(MouseEvent e) { maybeShowPopup(e);  }
  
   public void mouseClicked(MouseEvent e) {  }
    
   public void mouseEntered(MouseEvent e) { }

   public void mouseExited(MouseEvent e) { }
  
   public void maybeShowPopup(MouseEvent e) {
     if(e.isPopupTrigger()) popup.show(e.getComponent(),e.getX(),e.getY());
   }

   public void actionPerformed(ActionEvent e) {
     if( e.getSource() instanceof JMenuItem ) {
        JMenuItem source = (JMenuItem)(e.getSource());
        System.out.println(" action :"+source.getText());
        if( source == activate ) doActivate();
        else if( source == deactivate ) doDeactivate();
        else if( source == remove ) doRemove();
     }
   }// end of actionPerformed()

   public JButton getButton() { return button;}

   Component view;
   public void setView(Component a) { view=a; }
   public Component getView() { return view; }

   public void doActivate()   { 
     if(component!=null&&componentState==RTIComponent.COMPONENT_CREATED) 
     { component.activated();componentState=RTIComponent.COMPONENT_ACTIVATED; } 
   }

   public void doDeactivate() { 
     if(component!=null&&componentState==RTIComponent.COMPONENT_ACTIVATED) 
     { component.deactivated(); componentState=RTIComponent.COMPONENT_CREATED; } 
   }
  
   public void doRemove()     { 
     if(component!=null) { 
       if(componentState==RTIComponent.COMPONENT_ACTIVATED) doDeactivate();
       component.removed();
     }
     boss.removeRTIContext(aRec.getComponentName());
   }

   void loadComponent() {
     try {
       org.w3c.dom.Document dom = XmlDocument.createXmlDocument(boss.getCodeBase()+System.getProperty("file.separator")+aRec.getDefFileName());
       RTIComponentDocument compDocs = new RTIComponentDocument(dom);
       String cName = compDocs.getComponentName();
       compProperties = compDocs.getProperties();
       System.out.println("cName:"+cName);
       compDocs.printSummary(new PrintStream(System.out,true));
       component = boss.loadComponent(cName); 
       if( component!=null ) { 
         component.setContext(this); 
         component.created(); 
         componentState=RTIComponent.COMPONENT_CREATED;
       } else  System.out.println("component is NULL!! ");
     } catch(java.io.IOException ioe) {}
       catch(org.xml.sax.SAXException saxe) {}

   }// end of loadComponent()

  public void dispose()     {  System.out.println("dispose:");}
  public Properties getProperties()     {  return compProperties;}
  public String getProperty(String propertyName) { return (String)compProperties.get(propertyName); }

  public void registerMessageHandler(MessageHandler Hnd) {};
  public void registerMessageHandler(String federationName,MessageHandler Hnd) {};

  public MessageFactory getMessageFactory() {return null;};
  public MessageFactory getMessageFactory(String federationName) {return null;};
  public void setMessageFactory(String federationName, MessageFactory in) {};
  public void setMessageFactory(MessageFactory in) {};

  public MessagePublisher getMessagePublisher() { return null; };
  public MessagePublisher getMessagePublisher(String federationName) {return null; };
  public void setMessagePublisher(String federationName, MessagePublisher in) {};
  public void setMessagePublisher(MessagePublisher in) {};

} /* end interface RTIContextImpl */
