import java.util.*;
import java.io.*;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.text.html.*;
import javax.swing.event.*;
import java.net.*;

import RTIcap.*;             // The package containing our stubs.
import npacrti.*;            // The package containing our stubs.
import org.omg.CosNaming.*;  // 
import org.omg.CORBA.*;      // All CORBA applications need these classes.

import com.sun.xml.tree.*;
import org.w3c.dom.*;
import xml.*;
import org.xml.sax.*;

import comprti.*;
import lrti.*;
/**
*  This demo is prepared to demostrate how you can use OWRTI package.
*  This is a Chat program based on interactions.
*  
*
* @date May 11, 1998 ( Updated May 11, 1998 )
* @author H. Timucin Ozdemir
*
<changelog>
 <date>6.30.1999</date>
 <desc>gif images are added to the user interface.</desc>
 <date>7.1.1999</date>
 <desc>Buttons are enabled based on the current state. 
       states: A: Not Connected and no federation name.
               B: Not Connected with federation name
               C: Connected
       state transitions:
          A->Name->B
          B->Connect->C
          C->Disconnect->B
 </desc>
</changelog>
*/
public class RTILauncherGUI extends JFrame implements ActionListener, AppletProps, RTIContextRegistry {

   //String  fedName = "Chatter1";
   //String  fedCnfName = fedName+".fed";

   //short   federateId;
   ORB     orb;

   //String chatterTypeStr = new String("Chatter");
   //String chatterMsgTypeStr = new String("Message");

   String SetLoadTxt = new String("Load");
   String ExitTxt = new String("Exit");

   //short  chatterTypeId = -1;
   //int    chatterMsgTypeId = -1;

   java.lang.Object guard = new java.lang.Object();

   /** RTI Mappers */

   Hashtable className       = new Hashtable();
   Hashtable attributeName   = new Hashtable();
   Hashtable interactionName = new Hashtable();
   Hashtable parameterName   = new Hashtable();

   RTIcap.RTIambassador rtiAmb;

   boolean       advanceGranted = false;
   double        currentTime = 0.0; 
   double        timeStep = 5.0; 
   double        requestTime ; 

   /** Log File */
   PrintWriter myLog;

   JButton  connect;
   JButton  mail;
   JButton  disconnect;
   JButton  exit;
   JTextArea rcvMessages; 
   JTextField sendMessage; 

   short     myChatterId;

   boolean   isConnected = false;

   String    myChatterName = null;

   JMenuItem setLoadItem;

   JMenuItem exitItem;
   JPanel buttonPane ;
   JPopupMenu popup;

   String cnfFileNames = "components.xml";
   ComponentsDocument components;
   RTIComponentLoader loader = new RTIComponentLoader(".");
   Hashtable ctxmap = new Hashtable();
   FederationsRegistry fedreg ;
   RTIKernelInterface rtiKernel;

   /** */
   public RTILauncherGUI( RTIKernelInterface _rtiKernel, RTIcap.RTIambassador _rtiAmb, ORB _orb ) {
       rtiKernel=_rtiKernel;
       rtiAmb = _rtiAmb;
       orb = _orb;
       fedreg = new FederationsRegistryImpl(rtiKernel);
       loadComponentDescriptions(cnfFileNames);

       try 
       { myLog = new PrintWriter(new FileWriter("chat.log"),true);
       } catch( java.io.IOException ioe) {}
  
       JMenuBar menuBar = new JMenuBar();
       JMenu menu ;

       setJMenuBar(menuBar);
       
       //Build the first menu.
       menu = new JMenu("Menu");
       menuBar.add(menu);

       setLoadItem = new JMenuItem(SetLoadTxt);
       exitItem = new JMenuItem(ExitTxt);

       menu.add(setLoadItem);
       menu.add(exitItem);
       setLoadItem.addActionListener(this);
       exitItem.addActionListener(this);

       buttonPane = new JPanel();
       JScrollPane slider = new JScrollPane();buttonPane.setBackground(Color.white);
       
       //System.out.println("Before placeComponents()");
       placeComponents(components.getRegisteredComponents(),buttonPane,null);
       slider.add(buttonPane);

       JPanel contentPane = new JPanel();
       contentPane.setLayout(new BorderLayout());

       JPanel sPanel = new JPanel();
       sendMessage = new JTextField(30);
       sendMessage.addActionListener(this);

       contentPane.add(buttonPane,BorderLayout.CENTER);      
       contentPane.add(sPanel,BorderLayout.SOUTH);       

       setContentPane(contentPane);

   }// end of CONSTRUCTOR

   /** */ 
   public void loadComponentDescriptions(String fName) { 
     URL url = null;
     try {
      org.w3c.dom.Document dom = XmlDocument.createXmlDocument(getCodeBase()+System.getProperty("file.separator")+fName);
      components = new ComponentsDocument(dom);
      printComponents(components.getRegisteredComponents());
     } catch(java.io.IOException ioe) {}
       catch(org.xml.sax.SAXException sex) {}
   }// end of loadComponentDescriptions()

   
   /** */ 
   public URL getCodeBase() { 
     URL url = null;
     try
     {  url = new URL("file:"+System.getProperty("user.dir")+System.getProperty("file.separator"));
     } catch( MalformedURLException mue) {}
     return url;
   }// end of getCodeBase()

  /**
  */
  public Image getImage(URL url, String fName)
  { return Toolkit.getDefaultToolkit().getImage((url+fName)); }

   /**
   *
   * Gets the RTTI (Meta-Object Protocol MOP) handles.
   *
   * Ask RTI about the class indentifier of each object, attribute, 
   * interaction and parameter. So that we can define, subscribe, publish,
   * and interpret these attributes/objects.
   *
   *
   boolean getRtiIds()
   {
      boolean ret = false;

      if( rtiAmb != null )
      {
        
         try
         { 
           chatterTypeId = rtiAmb.getInteractionClassHandle(chatterTypeStr);
         } catch( RTIcap.NameNotFound icnd ) {}
           catch( RTIcap.FederateNotExecutionMember icnd ) {}
           catch( RTIcap.RTIinternalError icnd ) {}

         try
         { 
           chatterMsgTypeId = 
                  rtiAmb.getParameterHandle(chatterMsgTypeStr,chatterTypeId);
           ret = true;
         } catch( RTIcap.InteractionClassNotDefined icnd ) {}
           catch( RTIcap.NameNotFound icnd ) {}
           catch( RTIcap.FederateNotExecutionMember icnd ) {}
           catch( RTIcap.RTIinternalError icnd ) {}

      }// end of if
  
      return ret;

   }// end of getRtiIds()
   */

   /**
   *
   * Describe our interest for publishing objects and attributes.
   * Describe our interest for receiving objects and attributes.
   * Describe our interest for publishing interations and parameters.
   * Describe our interest for receiving interations and parameters.
   *
   *
   boolean publishSubscribe()
   {

      boolean ret = false;

      if( rtiAmb != null )
      {
         try
         {
           rtiAmb.subscribeInteractionClass( chatterTypeId, RTIcap._Boolean.RTI_TRUE);
         } catch( RTIcap.FederateLoggingServiceCalls  flsc) {}
           catch( RTIcap.FederateNotExecutionMember  fnem) {}
           catch( RTIcap.RTIinternalError  ie) {}
           catch( RTIcap.RestoreInProgress  rip) {}
           catch( RTIcap.InteractionClassNotDefined  icnd) {}
           catch( RTIcap.SaveInProgress  sip) {}

         try
         {
           rtiAmb.publishInteractionClass( chatterTypeId );
           ret = true;
         } catch( RTIcap.FederateNotExecutionMember fnem) {}
           catch( RTIcap.RestoreInProgress rip) {}
           catch( RTIcap.InteractionClassNotDefined icnd) {}
           catch( RTIcap.SaveInProgress sip) {}
           catch( RTIcap.RTIinternalError ie) {}

      }// end of if

      return ret;

   }// end of publishSubscribe()
   */
   /**
   * 
   * We want to join the Federation but we do not know its ID and
   * whether it is on. Therefore, we first try to create this Federation.
   * If this federation is  already exists, we will receive the exception.
   * If not, it will be created for us.
   * Then we need to join this execution and get ourself a federate id.
   * 
   *
   boolean joinFederationExecution(RTIcap.FederateAmbassador fedAmb)
   {

      boolean ret = false;

      if( rtiAmb != null )
      {

         try {
           rtiAmb.createFederationExecution(fedName,fedCnfName);
         } catch( RTIcap.FederationExecutionAlreadyExists icnd) {}
           catch( RTIcap.RTIinternalError ie) {}

         try
         {
           Date aDate = new Date();
           
           String aName = myChatterName+aDate;
             federateId = rtiAmb.joinFederationExecution(aName.replace(' ','_'),fedName,fedAmb);
             ret = true;
         } catch( RTIcap.FederateAlreadyExecutionMember fnem) {}
           catch( RTIcap.FederationExecutionDoesNotExist icnd) {}
           catch( RTIcap.CouldNotOpenFED fnem) {}
           catch( RTIcap.ErrorReadingFED fnem) {}
           catch( RTIcap.SaveInProgress sip) {}
           catch( RTIcap.RestoreInProgress rip) {}
           catch( RTIcap.RTIinternalError ie) {}

      }// end of if

      return ret;

   }// end of joinFederationExecution() 
   */
   /**
   *
   * Before we leave the Federation
   *  1. Delete all the object that we are suppose(promised) to simulate.
   *  2. resign from the federation.
   *  3. Try to destroy the federation execution. Note that if there 
   *     are still federates in the Federation, the federation execution
   *     won't be stopped. Only, we resign it. 
   *
   *
   void leaveFederationExecution()
   {

      if( rtiAmb != null )
      {

         try 
         {
           rtiAmb.resignFederationExecution(RTIcap.ResignAction.DELETE_OBJECTS_AND_RELEASE_ATTRIBUTES);
         } catch( RTIcap.InvalidResignAction ie) {}
           catch( RTIcap.FederateOwnsAttributes ie) {}
           catch( RTIcap.FederateNotExecutionMember ie) {}
           catch( RTIcap.RTIinternalError ie) {}

         try 
         {
           rtiAmb.destroyFederationExecution(fedName);
         } catch( RTIcap.FederationExecutionDoesNotExist icnd) {}
           catch( RTIcap.FederatesCurrentlyJoined ie) {}
           catch( RTIcap.RTIinternalError ie) {}

      }// end of if

   }// end of leaveFederationExecution() 
   */ 


   /**
   * ActionListener interface to collect the user events.
   * @param e ActionEvent
   */
   public void actionPerformed(ActionEvent e) {
     if( e.getSource() instanceof JMenuItem ) {
        JMenuItem source = (JMenuItem)(e.getSource());
        System.out.println(" action :"+source.getText());
        if( source == exitItem ) doExit();
        else if( source == setLoadItem ) doLoadComponent();
     }
     else if( e.getSource() instanceof JButton ) {
            JButton source = (JButton)(e.getSource());
            System.out.println(" action :"+source.getText());

            //( source ==  exit ) doExit();
            //else if( source ==  connect ) doConnect();
            //else if( source ==  disconnect ) doDisconnect();
            //else if( source ==  mail ) doMail();

          }
     else if( e.getSource() instanceof JTextField )
          {
            JTextField source = (JTextField)(e.getSource());
            System.out.println(" action :"+source.getText());
          }
     else if( e.getSource() instanceof JPanel && e.getSource() == buttonPane ) {
            System.out.println(" action : buttonPane");
          }


     //if( source.getText().equals(ExitTxt)) doExit();
     //else if( source.getText().equals(OpenURL) ) openURLProcess();

   }// end of actionPerformed()

   /**
   * Move the frame back, and destroy the execution.
   */
   void doExit()
   {
     toBack(); 
     if( isConnected ) {  isConnected=false; }
     System.exit(0);

   }// end of doExit()

   /**
   * Connects to the Federation Execution
   */
   void doRealyConnect()
   {
      int count = 0;

      myLog.println(" before ChatFedAmb definition ");

      /*******************************************************************/
      /** Define FederateAmbassador for HelloWorld. This objects serves  */
      /** as a callback mechanism so that RTI can bring us the necessary */ 
      /** events.                                                        */
      /*******************************************************************/
      ChatFedAmb fedAmb = null; //new ChatFedAmb(this);
      //orb.connect(fedAmb);
      org.omg.CORBA.ORB.init().connect(fedAmb);

      myLog.println(" ChatFedAmb is defined ");
      
      /************************************************************/
      /** Create FederationExecution, get RTI id of the objects,  */
      /** attributes, interactions, and parameters.               */
      /** Define interest for Subscription/Publishing.            */
      /** Define my simulated object.                             */
      /************************************************************/
      //if( joinFederationExecution(fedAmb) && getRtiIds() && publishSubscribe() )
      if(fedAmb!=null) {
        
        /*********************************************************************/
        /** TimeConstrained : we want to receive timestamped events in order */
        /*********************************************************************/
        //resetTimeAdvanceGranted();

        try
        { 
          rtiAmb.enableTimeConstrained( );
        } catch( RTIcap.TimeAdvanceAlreadyInProgress aa ) {}
          catch( RTIcap.EnableTimeConstrainedPending aa ) {}
          catch( RTIcap.TimeConstrainedAlreadyEnabled aa ) {}
          catch( RTIcap.FederateNotExecutionMember aa ) {}
          catch( RTIcap.SaveInProgress aa ) {}
          catch( RTIcap.RestoreInProgress aa ) {}
          catch( RTIcap.RTIinternalError aa ) {}

        /***************************************************/
        /** Tick RTI to get timeConstrainedEnabled message */
        /***************************************************/
        //tickRTI(2);

        /**********************************************************/
        /** TimeRegulating : We want to vote for time advancement */
        /**********************************************************/
        //resetTimeAdvanceGranted();

        try
        { 
          rtiAmb.enableTimeRegulation( currentTime, 5.0 );

        } catch( RTIcap.TimeAdvanceAlreadyInProgress aa ) {}
          catch( RTIcap.EnableTimeRegulationPending aa ) {}
          catch( RTIcap.ConcurrentAccessAttempted aa ) {}
          catch( RTIcap.TimeRegulationAlreadyEnabled aa ) {}
          catch( RTIcap.InvalidLookahead aa ) {}
          catch( RTIcap.InvalidFederationTime aa ) {}
          catch( RTIcap.FederateNotExecutionMember aa ) {}
          catch( RTIcap.SaveInProgress aa ) {}
          catch( RTIcap.RestoreInProgress aa ) {}
          catch( RTIcap.RTIinternalError aa ) {}

        /**************************************************/
        /** Tick RTI to get timeRegulationEnabled message */
        /**************************************************/
        //tickRTI(2);

        try
        { 
           rtiAmb.enableAsynchronousDelivery( );
           isConnected = true;

        } catch( RTIcap.FederateNotExecutionMember aa ) {}
          catch( RTIcap.AsynchronousDeliveryAlreadyEnabled aa ) {}
          catch( RTIcap.ConcurrentAccessAttempted aa ) {}
          catch( RTIcap.SaveInProgress aa ) {}
          catch( RTIcap.RestoreInProgress aa ) {}
          catch( RTIcap.RTIinternalError aa ) {}

      }// end of if 

      if(isConnected) {
         mail.setEnabled(true);
         disconnect.setEnabled(true);
         connect.setEnabled(false);
      }// end of if

   }// end of doRealyConnect()



   /**
   *
   void doMail()
   {
     if( !isConnected ) giveError(" You are disconnected! "); 
     else
      {
        try
        { 
           RTIcap.ParameterHandleValuePair vals[] = new RTIcap.ParameterHandleValuePair[1];
           vals[0] = new RTIcap.ParameterHandleValuePair((short)chatterMsgTypeId,(myChatterName+" : "+sendMessage.getText()).getBytes());
           rtiAmb.sendInteraction(chatterTypeId,vals,"");
           addMessage(myChatterName+" : "+sendMessage.getText(), Color.red);
           sendMessage.setText("");

        } catch( RTIcap.InteractionClassNotDefined aa ) {}
          catch( RTIcap.InteractionClassNotPublished aa ) {}
          catch( RTIcap.InteractionParameterNotDefined aa ) {}
          catch( RTIcap.FederateNotExecutionMember aa ) {}
          catch( RTIcap.SaveInProgress aa ) {}
          catch( RTIcap.RestoreInProgress aa ) {}
          catch( RTIcap.RTIinternalError aa ) {}
         try { rtiAmb.tick( ); } 
         catch( RTIcap.RTIinternalError aa ) {}


      }

   }// end of doMail()
   */


   /**
   */
   void doLoadComponent()
   {
     LoadComponentForm dialog = new LoadComponentForm(this);

     dialog.pack();
     dialog.setLocationRelativeTo(this);
     dialog.show();
     String myName        = dialog.getName().trim(); 
     String myImgFile     = dialog.getImageFile().trim(); 
     String myPath        = dialog.getPath().trim(); 
     String myUrl         = dialog.getUrl().trim(); 
     String myDefFileName = dialog.getDefFileName().trim(); 
    
     if( myName!=null && myDefFileName!=null ) {
       if( myName.trim().length()>0 && myDefFileName.trim().length()>0) {
         placeAComponent(new ComponentRecord(myName,myImgFile,myDefFileName,myPath,myUrl));
       }// end of if
     }// end of if

   }// end of doLoadComponent()

   JButton defineJButton(String bLabel, String iFile, 
                         String tip, int Mnemonic, boolean enabled) {
       ImageIcon theImage = null;
       try { theImage=new ImageIcon(new URL(getCodeBase()+iFile)); }
       catch(java.net.MalformedURLException mue) {}

       JButton ret    = new JButton(bLabel,theImage);
       ret.setToolTipText(tip);
       ret.setEnabled(enabled);
       ret.setMnemonic(Mnemonic);
       return ret;
   }

   JButton defineJButton(String bLabel, String iFile) {
       ImageIcon theImage = null;
       try { theImage=new ImageIcon(new URL(getCodeBase()+iFile)); }
       catch(java.net.MalformedURLException mue) {}

       JButton ret    = new JButton(bLabel,theImage);
       //ret.setToolTipText(tip);
       //ret.setEnabled(false);
       //ret.setMnemonic(Mnemonic);
       return ret; 
   }

   /**
   * Displays the error message in the warning window.
   * @param mess Error message.
   */
   void giveError(String mess)
   {
     JOptionPane.showMessageDialog( this, "Sorry!"+"\n"+mess,"",
                                    JOptionPane.ERROR_MESSAGE);

   }// end of giveError()


   class myButton extends JPanel {
      String label;
      public myButton(String aLabel) { add(new JLabel(aLabel)); }
   }

   void printComponents(Enumeration e) {
    if(e!=null && e.hasMoreElements() )
      while(e.hasMoreElements()) {
        ComponentRecord aRec = (ComponentRecord)e.nextElement();
        if(aRec!=null) aRec.print(System.out);
      }
   }

   void placeAComponent(JPanel buttonPane, ComponentRecord aRec) {
     /*System.out.print(" name:"+aRec.getComponentName());
     System.out.println(" imgf:"+aRec.getImageFileName());
     JButton oneButton = defineJButton(aRec.getComponentName(),aRec.getImageFileName());
     oneButton.setBackground(Color.pink); 
     oneButton.setVerticalTextPosition(AbstractButton.BOTTOM);
     oneButton.setHorizontalTextPosition(AbstractButton.CENTER);       
     buttonPane.add(oneButton);
     RTIContextImpl ctx = new RTIContextImpl(oneButton,aRec,this);
     oneButton.addMouseListener(ctx);
     addRTIContext(aRec.getComponentName(),ctx);*/
     System.out.println("Loading :"+aRec.getComponentName());
     RTIContextImpl ctx = RTIContextFactory.create(aRec,this,fedreg,this);
     if(ctx!=null) addRTIContext(ctx);
     else System.out.println(aRec.getComponentName()+" is NULL!! ");
  }

   void placeComponents(Enumeration e, JPanel buttonPane, MouseListener ml) {
    if(e!=null && e.hasMoreElements() )
      while(e.hasMoreElements()) {
        ComponentRecord aRec = (ComponentRecord)e.nextElement();
        if(aRec!=null) placeAComponent(buttonPane,aRec);
      }
   }

   public void placeAComponent(ComponentRecord aRec) {
    if(aRec!=null) { placeAComponent(buttonPane,aRec); buttonPane.doLayout(); buttonPane.repaint(); }
   }

   public RTIComponent loadComponent( String compName ) {
     return loader.loadRTIComponentObject(compName);
   }// end of loadComponent()

   public RTIContext getRTIContext(String nm) { return (RTIContext)ctxmap.get(nm); }
   public void addRTIContext(String nm, RTIContext item) { 
     if(nm!=null&&item!=null) {
       ctxmap.put(nm,item);   buttonPane.add(item.getView());
       buttonPane.doLayout(); buttonPane.repaint();
     }// end of if
   }// end of addRTIContext()
   public void removeRTIContext(String nm) {  
     RTIContextImpl item=(RTIContextImpl)getRTIContext(nm);
     if(item!=null) { ctxmap.remove(nm); buttonPane.remove(item.getView());
                      buttonPane.doLayout(); buttonPane.repaint(); item.dispose(); } 
   }

   public void addRTIContext(RTIContext in) { addRTIContext(in.toString(),in); }
   public void removeRTIContext(RTIContext in) { removeRTIContext(in.toString()); };

}// end of RTILauncherGUI()

