package comprti;
import  java.util.*;
import  comprti.msg.*;

/** 
* @see Message, MessagePublisher 
* @author H. Timucin Ozdemir
* @date August 6, 1999 (Updated on August 7, 1999)
*/
public abstract class 
BaseMessagePublisher implements MessagePublisher, Runnable {
  Vector msgs = new Vector();
  Object guard = new Object();
  boolean     running=false;
  Thread      runner=null;
  public BaseMessagePublisher()   { running=false; start(); }
  public synchronized void start() 
  { if( runner==null ) runner = new Thread(this); runner.start(); }
  public synchronized void stop() 
  { running=false; if( runner!=null ) { runner.stop(); runner=null; } }
  public synchronized void push(Message inMsg) 
  { synchronized(guard) { msgs.addElement(inMsg); } notifyAll(); }
  public synchronized void run() {
    running=true;
    while(running) {
      while( msgs.size()<1 )
      try {  wait(); } catch (InterruptedException ie) { continue; }
      Vector pmsgs=null;
      synchronized(guard) { pmsgs=msgs; msgs=new Vector(); }
      if(pmsgs!=null&&pmsgs.size()>0) {
        Enumeration e = pmsgs.elements();
        Message aMsg;
        while(e.hasMoreElements() ) 
          if((aMsg=(Message)e.nextElement())!=null) dispatch(aMsg);
      }// end of if 
    }// end of while 
  }// end of run()
  protected abstract void dispatch(Message inMsg);
} // end of class BaseMessagePublisher 
