package comprti.cback;

import java.util.*;
import comprti.msg.*;
import comprti.*;

/** 
* @see MessageHandler, CallbackInvoker 
* @author H. Timucin Ozdemir
* @date August 6, 1999 (Updated on August 1999)
*/
public class CallbackRepository {
  MessageHandler target;
  CallbackInvoker dCallbackInvoker;
  Hashtable attributes = new Hashtable();
  Hashtable parameters = new Hashtable();
  public CallbackRepository(MessageHandler _target) {
    target=_target;
    dCallbackInvoker=new CallbackInvoker(target);
  }// end of CONSTRUCTOR

  public CallbackInvoker getDefaultCallback() { return dCallbackInvoker; }
  public CallbackInvoker getCallbackForAttribute(String objName, String aName) {
    CallbackInvoker ret=(CallbackInvoker)attributes.get(objName+"."+aName);
    return (ret!=null?ret:dCallbackInvoker);
  }// end of getCallbackForAttribute()  

  public CallbackInvoker 
  getCallbackForParameter(String interactionName, String paramName) {
    CallbackInvoker ret=(CallbackInvoker)parameters.get(interactionName+"."+paramName);
    return (ret!=null?ret:dCallbackInvoker);
  }// end of getCallbackForParameter()

  public void addCallbackForAttribute(String objName, String aName, String methodName) {
    CallbackInvoker ret=(CallbackInvoker)attributes.get(objName+"."+aName);
    if(ret==null) {
      try { Object args[] = new Object[2];
            args[0]= new Integer(0);
            args[1]= new byte[2]; 
        ret=new DCallbackInvoker(target,methodName,args); 
        attributes.put(objName+"."+aName,ret);
      } catch(IllegalArgumentException iae) {}
    }// end of if
  }// end of addCallbackForAttribute()  

  public void 
  addCallbackForParameter(String interactionName, String paramName, String methodName) {
    CallbackInvoker ret=(CallbackInvoker)parameters.get(interactionName+"."+paramName);
    System.out.println("addCallbackForParameter("+interactionName+","+paramName+","+methodName+")"); 
    if(ret==null) {
      try { Object args[] = new Object[1];
            args[0]= new byte[2]; 
        ret=new DCallbackInvoker(target,methodName,args); 
        parameters.put(interactionName+"."+paramName,ret);
      } catch(IllegalArgumentException iae) 
        { System.out.println("IllegalArgumentException for "+methodName); }
    }// end of if  
  }// end of addCallbackForParameter()

} // end of class CallbackRepository 
