
package comprti.queue;


/**
* List element implementation
*
* @author Zeynep Odcikin-Ozdemir
* @date   Dec 20, 1998
*
*/
public class ListItem 
{
 
  /** Next Pointer */
  ListItem  nxt;
 
  /** Previous Pointer */
  ListItem  prv;

  /** Object reference */
  Object    value;

  /**
  * @param _value A reference to object for keeping.
  */
  public ListItem(Object _value)
  {
     nxt = prv = null;
     value = _value;
  }// end of constructor
 
  /**
  * @return the next ListItem.
  */
  public ListItem next() { return nxt; }
  
  /** 
  * @return the previous ListItem.
  */
  public ListItem prev() { return prv; }

  /** 
  * @return an object in the ListItem.
  */
  public Object getObject() { return value; }

  /**
  * Sets the next pointer.
  * @param _nxt  a ListItem.
  */
  public void next(ListItem _nxt) { nxt=_nxt; }
  
  /** 
  * Sets the previous pointer.
  * @param _prv a ListIte
  */
  public void prev(ListItem _prv) { prv=_prv; }

}// end of ListItem()

