package comprti.queue;
import java.util.*;
/**
*
* A NotifierThread inokes available() method on the
* Notifier objets.
*
* @author Zeynep Odcikin-Ozdemir
* @date   Dec 20, 1998
* 
*/
public class NotifierThread implements Runnable {

  /** A set of Notifier objects */
  Enumeration e;
  /** state of the thread */
  boolean     running=false;
  /** Thread object */
  Thread      runner=null;
  NotifierAdmin na;

  /** */
  public NotifierThread(NotifierAdmin _na) { na=_na;e = null; running=false; start(); }

  /** */
  public void start() {  
     if( runner==null ) runner = new Thread(this);
     runner.start();
  }// end of start()

  /** */
  public void stop() {  
     running=false;
     if( runner!=null ) { runner.stop(); runner=null; }
     System.out.println(this+" stop()! ");
  }// end of start()

  /** */
  public synchronized void run()   { 
    running = true;
    while(running) {
       while( isNULL() ) 
         try {  wait(); } catch (InterruptedException ie) { continue; }
       Enumeration a = e; 
       e=null;
       doNotify(a);
    }// end of while()
  }// end of run()

  /**
  * This message starts the thread.
  * @param _e a set of Notifier objects.
  */
  public synchronized void broadcast(Enumeration _e) { 
    System.out.println(" broacast! ");
    if( _e.hasMoreElements() ) { e=_e; this.notifyAll(); }
  }// end of broadcast()

  /**
  */
  public synchronized boolean isNULL() { return (e==null); }// end of isNULL()

  /***/
  void doNotify( Enumeration a ) {
     Notifier b ;
     while( a.hasMoreElements() )
        if((b=(Notifier)a.nextElement())!=null) b.available();
     if(na!=null) na.setFree(this);
  }// end of doNotify()

}// end of NotifierThread()

