package lrti;
import java.util.*;
import lrti.*;
import lrti.rtidb.*;
import lrti.rtidb.inmem.*;
import RTIcap.*;             // The package containing our stubs.
import npacrti.*;            // The package containing our stubs.
/** 
* @see 
* @author 
*/
public class FederationsRegistryImpl implements FederationsRegistry {
  RTIKernelInterface rtiKernel;
  Hashtable fedcomms = new Hashtable();
  Random rnd = new Random();
  public FederationsRegistryImpl(RTIKernelInterface _rtiKernel) throws IllegalArgumentException {
    if(_rtiKernel==null) 
       throw new IllegalArgumentException("FederationsRegistry::RTIKernelInterface is NULL!");
    rtiKernel=_rtiKernel;
  }
  public void remove(String fedName) throws IllegalArgumentException {
    if(fedName==null) 
       throw new IllegalArgumentException("FederationsRegistry::Federation name is NULL!");
    FederationDefinition ret = (FederationDefinition)fedcomms.get(fedName);
    if(ret==null) 
       throw new IllegalArgumentException("FederationsRegistry::Already removed !");
    fedcomms.remove(fedName);
  }// end of get()

  public FederationDefinition get(String fedName) throws IllegalArgumentException {
    if(fedName==null) 
       throw new IllegalArgumentException("FederationsRegistry::Federation name is NULL!");
    FederationDefinition ret = (FederationDefinition)fedcomms.get(fedName);
    if(ret==null) ret = askKernel(fedName);
    return ret;
  }// end of get()

  FederationDefinition askKernel(String fedName) throws IllegalArgumentException {
    RTIambassador rtiAmb = rtiKernel.createRTIAmbassador();
    AggregatedFedAmb fedAmb = new AggregatedFedAmb(fedName);
    String  fedCnfName = fedName+".fed";
    boolean status=true;
    String reason="FederationsRegistry::";
    Date aDate = new Date();
    String aName = Long.toHexString(rnd.nextLong())+aDate;
    short federateId=-1;
    FederationDefinition ret=null;

    try 
    { rtiAmb.createFederationExecution(fedName,fedCnfName); } 
    catch( RTIcap.FederationExecutionAlreadyExists icnd) {}
    catch( RTIcap.RTIinternalError ie) 
    { status=false;reason+="RTIcap.RTIinternalError";}

    if(status) 
      try 
      { 
        federateId = rtiAmb.joinFederationExecution(aName.replace(' ','_'), fedName,fedAmb);
      } catch( RTIcap.FederateAlreadyExecutionMember fnem) 
        { status=false;reason+=(aName+"FederateAlreadyExecutionMember ");}
        catch( RTIcap.FederationExecutionDoesNotExist icnd) 
        { status=false;reason+=("FederationExecutionDoesNotExist ");}
        catch( RTIcap.CouldNotOpenFED fnem) 
        { status=false;reason+=("CouldNotOpenFED "+fedCnfName);}
        catch( RTIcap.ErrorReadingFED fnem) 
        { status=false;reason+=("ErrorReadingFED "+fedCnfName);}
        catch( RTIcap.SaveInProgress sip) 
        { status=false;reason+=("SaveInProgress ");}
        catch( RTIcap.RestoreInProgress rip) 
        { status=false;reason+=("RestoreInProgress ");}
        catch( RTIcap.RTIinternalError ie) 
        { status=false;reason+=("RTIinternalError ");}
    if(status) {
     ret=new FederationDefinition(fedName,federateId,rtiAmb,fedAmb);
     fedcomms.put(fedName,ret);
    } else throw new IllegalArgumentException(reason);
    return ret;
  }// end of askKernel()

} // end of class FederationsRegistry

