package lrti.rtidb.inmem;

import java.util.*;
import lrti.rtidb.*;

/** 
 * 
 * @see 
 * @author 
 */
public class InMemRTIInteractionLookUp implements RTIInteractionLookUp {
  Hashtable interactionName_to_record = new Hashtable();
  Hashtable interactionId_to_record = new Hashtable();

  public InMemRTIInteractionLookUp() {
  }// end of CONSTRUCTOR

  public int getInteractionClassId(String interactionName) {
    int ret=-1;
    RTIInteractionClassRecord aRec = (RTIInteractionClassRecord)interactionName_to_record.get(interactionName);
    if(aRec!=null) ret=aRec.getInteractionClassId();
    return ret;
  }

  public String getInteractionClassName(int interactionId) {
    String ret=null;
    RTIInteractionClassRecord aRec = (RTIInteractionClassRecord)interactionId_to_record.get(new Integer(interactionId));
    if(aRec!=null) ret=aRec.getInteractionClassName();
    return ret;
  }

  public int getParameterId(String interactionName,String paramName) {
    int ret=-1;
    RTIInteractionClassRecord aRec = (RTIInteractionClassRecord)interactionName_to_record.get(interactionName);
    if(aRec!=null) ret=aRec.getParameterId(paramName);
    return ret;
  }

  public int getParameterId(int interactionId, String paramName) {
    int ret=-1;
    RTIInteractionClassRecord aRec = (RTIInteractionClassRecord)interactionId_to_record.get(new Integer(interactionId));

    if(aRec!=null) ret=aRec.getParameterId(paramName);
    return ret;
  }

  public String getParameterName(String interactionName,int paramId) {
    String ret=null;
    RTIInteractionClassRecord aRec = (RTIInteractionClassRecord)interactionName_to_record.get(interactionName);
    if(aRec!=null) ret=aRec.getParameterName(paramId);
    return ret;
  }

  public String getParameterName(int interactionId,int paramId) {
    String ret=null;
    RTIInteractionClassRecord aRec = (RTIInteractionClassRecord)interactionId_to_record.get(new Integer(interactionId));
    if(aRec!=null) ret=aRec.getParameterName(paramId);
    return ret;
  }
  public void addInteractionClass(String interactionName, int interactionId) 
         throws RTIDBException {

    int    ret  = getInteractionClassId(interactionName);
    String retS = getInteractionClassName(interactionId);
    if(ret<0&&retS==null) { 
      RTIInteractionClassRecord aRec=new RTIInteractionClassRecord(interactionName,interactionId);
      interactionName_to_record.put(interactionName,aRec);
      interactionId_to_record.put(new Integer(interactionId),aRec);
    } else {
       String eMsg = new String("ERROR: ");
       if(ret>=0) eMsg += ("Interaction "+interactionName+" is already defined\n");
       if(retS!=null) eMsg += ("Interaction Id "+interactionId+" is already defined\n");
       throw new RTIDBException(eMsg);
      }

  }// end of addInteractionClass()

  public void addParameter(String interactionName,String paramName,int paramId)
         throws RTIDBException {
    int    ret  = getInteractionClassId(interactionName);
    String eMsg = new String("ERROR: ");
    boolean error = false;
    if(ret>0) { 
      RTIInteractionClassRecord aRec=(RTIInteractionClassRecord)interactionName_to_record.get(interactionName);
      aRec.addParameter(paramName,paramId);
    } else { 
       error=true;
       eMsg += ("Interaction "+interactionName+" is not defined\n");
      }
    if(error)  throw new RTIDBException(eMsg);
  }// end of addParameter()

} // end of class InMemRTIInteractionLookUp

