package lrti.rtidb.inmem;

import java.util.*;
import lrti.rtidb.*;

/** 
 * 
 * @see 
 * @author 
 */
public class 
InMemRTIObjectClassAttributeLookUp implements RTIObjectClassAttributeLookUp {
  Hashtable objectName_to_record = new Hashtable();
  Hashtable objectId_to_record = new Hashtable();

  public InMemRTIObjectClassAttributeLookUp() {
  }// end of CONSTRUCTOR

  public int getObjectClassId(String objectName) {
    int ret=-1;
    RTIObjectClassRecord aRec = (RTIObjectClassRecord)objectName_to_record.get(objectName);
    if(aRec!=null) ret=aRec.getObjectClassId();
    return ret;
  }

  public String getObjectClassName(int objectClassId) {
    String ret=null;
    RTIObjectClassRecord aRec = (RTIObjectClassRecord)objectId_to_record.get(new Integer(objectClassId));
    if(aRec!=null) ret=aRec.getObjectClassName();
    return ret;
  }

  public int getAttributeId(String objectClassName,String attributeName) {
    int ret=-1;
    RTIObjectClassRecord aRec = (RTIObjectClassRecord)objectName_to_record.get(objectClassName);
    if(aRec!=null) ret=aRec.getAttributeId(attributeName);
    return ret;
  }

  public int getAttributeId(int objectClassId, String attributeName) {
    int ret=-1;
    RTIObjectClassRecord aRec = (RTIObjectClassRecord)objectId_to_record.get(new Integer(objectClassId));

    if(aRec!=null) ret=aRec.getAttributeId(attributeName);
    return ret;
  }

  public String getAttributeName(String objectClassName,int attributeId) {
    String ret=null;
    RTIObjectClassRecord aRec = (RTIObjectClassRecord)objectName_to_record.get(objectClassName);
    if(aRec!=null) ret=aRec.getAttributeName(attributeId);
    return ret;
  }

  public String getAttributeName(int objectClassId,int attributeId) {
    String ret=null;
    RTIObjectClassRecord aRec = (RTIObjectClassRecord)objectId_to_record.get(new Integer(attributeId));
    if(aRec!=null) ret=aRec.getAttributeName(attributeId);
    return ret;
  }// end of getAttributeName()

  public void addObjectClass(String objectName, int objectClassId) 
         throws RTIDBException {

    int    ret = getObjectClassId(objectName);
    String retS = getObjectClassName(objectClassId);
    if(ret<0&&retS==null) {
      RTIObjectClassRecord aRec = new RTIObjectClassRecord(objectName,objectClassId);
      objectName_to_record.put(objectName,aRec);
      objectId_to_record.put(new Integer(objectClassId),aRec);
    } else {
        String eMsg = "ERROR : ";
        if(ret>=0) eMsg += ("Object class "+objectName+" is already defined!");
        if(retS!=null) eMsg += ("Object id "+objectClassId+" is already defined!");
        throw new RTIDBException(eMsg);
      }// end of else
  }// end of addObjectClass()

  public void addAttribute(String objectName,String attributeName,int attributeId)
         throws RTIDBException {
    int    ret = getObjectClassId(objectName);
    String eMsg = "ERROR : ";
    boolean error = false; 
    if(ret>=0) {
      RTIObjectClassRecord aRec = (RTIObjectClassRecord)objectName_to_record.get(objectName);
      aRec.addAttribute(attributeName,attributeId);
    } else {
        error=true;
        eMsg += ("Object class "+objectName+" is not defined!");
      }// end of else
    if(error) throw new RTIDBException(eMsg);
  }// end of addAttribute()

} // end of class InMemRTIObjectClassAttributeLookUp

