package xml;

import org.w3c.dom.*;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Stack;
import java.io.PrintStream;
import java.net.*;

/**
*
* @date   September 26, 1998 ( Last Updated September 26, 1998 )
* @author H. Timucin Ozdemir
*
*/
public class 
ComponentRecord implements XMLDebugFlags, ComponentsConstants {
   /** */
   String component_name;
   String image_fileName;
   String cmpDefFileName;
   String cmpDefFilePath;
   String cmpDefFileUrl;

   /** */
   public ComponentRecord(String _component_name, String _image_fileName,
                          String _cmpDefFileName, String _cmpDefFilePath,
                          String _cmpDefFileUrl) {
     component_name = new String(_component_name);
     image_fileName = new String(_image_fileName);
     cmpDefFileName = new String(_cmpDefFileName);
     cmpDefFilePath = new String(_cmpDefFilePath);
     cmpDefFileUrl  = new String(_cmpDefFileUrl);
   }// end of CONSTRUCTOR

   public final String getComponentName( ) { return component_name; }
   public final String getImageFileName( ) { return image_fileName ; }
   public final String getDefFileName( ) { return cmpDefFileName; }
   public final String getDefFilePath( ) { return cmpDefFilePath; }
   public final String getDefFileUrl( ) { return cmpDefFileUrl; }

   /** */
   public void print(PrintStream o) { 
      o.println( "<"+ComponentItemLabel+" "+nameLabel+"=\""+getComponentName()+"\">");
      if( image_fileName!=null )
       o.println( "<"+imgLabel+" "+fileLabel+"=\""+image_fileName+"\"/>");
      o.println( "<"+fileNameLabel+">");
      if( cmpDefFileName!=null )
       o.println( "<"+nameLabel+">"+cmpDefFileName+"</"+nameLabel+">");
      if( cmpDefFilePath!=null )
       o.println( "<"+pathLabel+">"+cmpDefFilePath+"</"+pathLabel+">");
      if( cmpDefFileUrl!=null )
       o.println( "<"+urlLabel+">"+cmpDefFileUrl+"</"+urlLabel+">");
      o.println( "</"+fileNameLabel+">");
      o.println( "</"+ComponentItemLabel+">");
   }// end of print()

}// end of ComponentRecord
