package xml;
import java.io.PrintStream;
import util.*;
import util.inmem.*;
/**
* @date   August 6, 1999 ( Last Updated August 6, 1999 )
* @author H. Timucin Ozdemir
*/
public class JoinedFedInfo {
  String fedName;
  FedPubSubInfo fPubSubInfo ;
  CallbackRegistry oCallbackRegistry = new InMemCallbackRegistry();
  CallbackRegistry iCallbackRegistry = new InMemCallbackRegistry();
  public JoinedFedInfo(String _fedName) 
  { fedName=_fedName; fPubSubInfo = new FedPubSubInfo(fedName); }
  public String getFederationName()                        { return fedName; }
  public FedPubSubInfo getFedPubSubInfo()                  { return fPubSubInfo; }
  public CallbackRegistry getObjectCallbackRegistry()      { return oCallbackRegistry; }
  public CallbackRegistry getInteractionCallbackRegistry() { return iCallbackRegistry; }
  public void print(PrintStream o)  { 
    o.println(">Federation Name: "+fedName);
    fPubSubInfo.print(o);
    o.println(">Object Callbacks ");
    oCallbackRegistry.print(o);
    o.println(">Interaction Callbacks ");
    iCallbackRegistry.print(o);
  }// end of print()
}// end of JoinedFedInfo
